/**
 * /script/classes.js
 * @version 1.0
 * @desc Javascript file for the classes submenu
 * @author Fándly Gergő Zoltán (fandlygergo@gmail.hu, systemtest.tk)
 * @copy 2017 Fándly Gergő Zoltán
 * License:
    Result Manager for managing results of students in bilingual school systems.
    Copyright (C) 2017  Fándly Gergő Zoltán

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 **/

function classesLoadList(){
    $("#list").slideUp(function(){
        $.ajax({
            url: "./subs/loader.php?load=classes&backend&list",
            type: "GET",
            success: function(response){
                $("#list").html(response);
                $(".table").footable();
                $("#list").slideDown();
            }
        });
    });
}

function classesFilterApply(){
    $("#list").slideUp(function(){
        $.ajax({
            url: "./subs/loader.php?load=classes&backend&list",
            type: "POST",
            data: $("#dd_filter_form").serialize(),
            success: function(response){
                $("#list").html(response);
                $(".table").footable();
                $("#list").slideDown();
            }
        });
    });
}

function classesFilterReset(){
    $("#dd_filter_form")[0].reset();
    classesLoadList();
}

/*
 * RUN
 */
//autoload list
classesLoadList();
