<?php
/**
 * /subs/loader.php
 * @version 1.0
 * @desc Loader for component pages
 * @author Fándly Gergő Zoltán (fandlygergo@gmail.hu, systemtest.tk)
 * @copy 2017 Fándly Gergő Zoltán
 * License:
    Result Manager for managing results of students in bilingual school systems.
    Copyright (C) 2017  Fándly Gergő Zoltán

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 **/

if(!isset($BOM)){
    require_once("../config/config.php");
}

function loadPart($view, $backend=false){
    global $lm, $lang, $db, $BOM, $config, $schoolyear;
    if($lm->validateLogin()){
        if($view!="" && $view!="users" && $view!="classes" && $view!="subjects" && $view!="contests" && $view!="phases" && $view!="register" && $view!="wizard" && $view!="profile" && $view!="admin"){
            functions::setError(404);
            $view="";
        }
        
        if(($view=="users") && $_SESSION['accesslevel']<3){
            functions::setError(401);
            $view="";
        }
        else if(($view=="classes" || $view=="subjects" || $view=="contests" || $view=="phases" || $view=="register" || $view=="wizard") && $_SESSION['accesslevel']<1){
            functions::setError(401);
            $view="";
        }
        else if(($view=="admin") && $_SESSION['accesslevel']<4){
            functions::setError(401);
            $view="";
        }
    }
    
    if($backend){
        include("part/".$view."_backend.php");
    }
    else{
        include("part/".$view.".php");
    }
}

if(isset($_GET['load'])){
    loadPart($_GET['load'], isset($_GET['backend']));
}
