<?php
/**
 * /subs/profile_backend.php
 * @version 1.0
 * @desc backend for profile
 * @author Fándly Gergő Zoltán (fandlygergo@gmail.hu, systemtest.tk)
 * @copy 2017 Fándly Gergő Zoltán
 * License:
    Result Manager for managing results of students in bilingual school systems.
    Copyright (C) 2017  Fándly Gergő Zoltán

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 **/

try{
    
    if(isset($_POST['password']) && isset($_POST['password_confirm'])){
        if($_POST['password']!=$_POST['password_confirm']){
            functions::setError(10);
        }
        else{
            $sql=$db->prepare("UPDATE users SET password=:passwd WHERE id=:id");
            $sql->execute(array(":passwd"=>PasswordStorage::create_hash($_POST['password']), ":id"=>$_SESSION['id']));
            $res=$sql->rowCount();
            if($res>0){
                functions::setMessage(6);
            }
            else{
                functions::setError(4);
            }
        }
    }
    
}
catch(Exception $e){
    functions::setError(500);
    error_log($e);
}
